Bug 4571 - 4.0.2 globus-url-copy core dumps with -cd -f option on x86_64
: 4.0.2 globus-url-copy core dumps with -cd -f option on x86_64
Status: RESOLVED FIXED
: GridFTP
globus-url-copy
: unspecified
: PC Linux
: P3 blocker
: ---
Assigned To:
:
:
:
:
  Show dependency treegraph
 
Reported: 2006-07-05 20:14 by
Modified: 2006-09-15 19:57 (History)


Attachments


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2006-07-05 20:14:05
Input file contains 5 entries as listed below.

gsiftp://intensity.usc.edu/data/gmehta/storage/SeisMeta_allCSUN_405_18.metadata
file:///home/rcf-104/CyberShake/gmehta/scratch/scec-CSUN/gmehta/CybershakeTemplate1/run0008/SeisMeta_allCSUN_405_18.metadata
gsiftp://intensity.usc.edu/home/gmehta/CyberShake/CSUN/edge/eh.modPS
file:///home/rcf-104/CyberShake/gmehta/scratch/scec-CSUN/gmehta/CybershakeTemplate1/run0008/eh.modPS
gsiftp://intensity.usc.edu/data/gmehta/storage/SeisMeta_allCSUN_144_1.metadata
file:///home/rcf-104/CyberShake/gmehta/scratch/scec-CSUN/gmehta/CybershakeTemplate1/run0008/SeisMeta_allCSUN_144_1.metadata
gsiftp://intensity.usc.edu/data/gmehta/storage/SeisMeta_allCSUN_471_7.metadata
file:///home/rcf-104/CyberShake/gmehta/scratch/scec-CSUN/gmehta/CybershakeTemplate1/run0008/SeisMeta_allCSUN_471_7.metadata
gsiftp://intensity.usc.edu/data/gmehta/storage/SeisMeta_allCSUN_104_0.metadata
file:///home/rcf-104/CyberShake/gmehta/scratch/scec-CSUN/gmehta/CybershakeTemplate1/run0008/SeisMeta_allCSUN_104_0.metadata

The command invocation is 
globus-url-copy -vb -cd -f /tmp/gmehta.test.in
Source: gsiftp://intensity.usc.edu/data/gmehta/storage/
Dest:  
file:///home/rcf-104/CyberShake/gmehta/scratch/scec-CSUN/gmehta/CybershakeTemplate1/run0008/
  SeisMeta_allCSUN_405_18.metadata

Source: gsiftp://intensity.usc.edu/home/gmehta/CyberShake/CSUN/edge/
Dest:  
file:///home/rcf-104/CyberShake/gmehta/scratch/scec-CSUN/gmehta/CybershakeTemplate1/run0008/
  eh.modPS

Source: gsiftp://intensity.usc.edu/data/gmehta/storage/
Dest:  
file:///home/rcf-104/CyberShake/gmehta/scratch/scec-CSUN/gmehta/CybershakeTemplate1/run0008/
  SeisMeta_allCSUN_144_1.metadata
Segmentation fault (core dumped)

This error happens using both the x86_AS3 and x86_64_AS3 binaries

If the -cd option is not give then the client works fine.


gdb trace from the core file is

(gdb) set pagination off
(gdb) set history save
(gdb) set print array on
(gdb) set print pretty on
(gdb) set print elements 0
(gdb) where
#0  0x0000002a96ad5a01 in globus_object_type_assert_valid () from
/auto/rcf-104/CyberShake/gmehta/software/globus/4.0.2//lib/libglobus_common_gcc64.so.0
#1  0x0000002a96ad5a77 in globus_object_assert_valid () from
/auto/rcf-104/CyberShake/gmehta/software/globus/4.0.2//lib/libglobus_common_gcc64.so.0
#2  0x0000002a96ad5cd2 in globus_object_free () from
/auto/rcf-104/CyberShake/gmehta/software/globus/4.0.2//lib/libglobus_common_gcc64.so.0
#3  0x0000002a96accf11 in s_base_instance_destructor () from
/auto/rcf-104/CyberShake/gmehta/software/globus/4.0.2//lib/libglobus_common_gcc64.so.0
#4  0x0000002a96ad5d19 in globus_object_free () from
/auto/rcf-104/CyberShake/gmehta/software/globus/4.0.2//lib/libglobus_common_gcc64.so.0
#5  0x0000002a96ad5d29 in globus_object_free () from
/auto/rcf-104/CyberShake/gmehta/software/globus/4.0.2//lib/libglobus_common_gcc64.so.0
#6  0x0000002a96ad60d8 in globus_object_cache_insert () from
/auto/rcf-104/CyberShake/gmehta/software/globus/4.0.2//lib/libglobus_common_gcc64.so.0
#7  0x0000002a96acce17 in globus_error_put () from
/auto/rcf-104/CyberShake/gmehta/software/globus/4.0.2//lib/libglobus_common_gcc64.so.0
#8  0x0000002a9649db6d in globus_i_gsi_sysconfig_error_result () from
/auto/rcf-104/CyberShake/gmehta/software/globus/4.0.2//lib/libglobus_gsi_sysconfig_gcc64.so.0
#9  0x0000002a9649a7c4 in globus_gsi_sysconfig_dir_exists_unix () from
/auto/rcf-104/CyberShake/gmehta/software/globus/4.0.2//lib/libglobus_gsi_sysconfig_gcc64.so.0
#10 0x0000002a9649932c in globus_i_gsi_sysconfig_create_cert_dir_string () from
/auto/rcf-104/CyberShake/gmehta/software/globus/4.0.2//lib/libglobus_gsi_sysconfig_gcc64.so.0
#11 0x0000002a9649aeb3 in globus_gsi_sysconfig_get_cert_dir_unix () from
/auto/rcf-104/CyberShake/gmehta/software/globus/4.0.2//lib/libglobus_gsi_sysconfig_gcc64.so.0
#12 0x0000002a95f5b0a3 in globus_i_gsi_gss_create_and_fill_context () from
/auto/rcf-104/CyberShake/gmehta/software/globus/4.0.2//lib/libglobus_gssapi_gsi_gcc64.so.0
#13 0x0000002a95f5850b in gss_init_sec_context () from
/auto/rcf-104/CyberShake/gmehta/software/globus/4.0.2//lib/libglobus_gssapi_gsi_gcc64.so.0
#14 0x0000002a95c11d64 in globus_l_xio_gsi_open_cb () from
/auto/rcf-104/CyberShake/gmehta/software/globus/4.0.2//lib/libglobus_xio_gcc64.so.0
#15 0x0000002a95c045f3 in globus_l_xio_driver_open_op_kickout () from
/auto/rcf-104/CyberShake/gmehta/software/globus/4.0.2//lib/libglobus_xio_gcc64.so.0
#16 0x0000002a95c09e58 in globus_xio_driver_finished_open () from
/auto/rcf-104/CyberShake/gmehta/software/globus/4.0.2//lib/libglobus_xio_gcc64.so.0
#17 0x0000002a95c22a0b in globus_l_xio_tcp_system_connect_cb () from
/auto/rcf-104/CyberShake/gmehta/software/globus/4.0.2//lib/libglobus_xio_gcc64.so.0
#18 0x0000002a95c0bffb in globus_l_xio_system_kickout () from
/auto/rcf-104/CyberShake/gmehta/software/globus/4.0.2//lib/libglobus_xio_gcc64.so.0
#19 0x0000002a96acb4d7 in globus_callback_space_poll () from
/auto/rcf-104/CyberShake/gmehta/software/globus/4.0.2//lib/libglobus_common_gcc64.so.0
#20 0x0000000000403fa7 in globus_l_guc_transfer_files ()
#21 0x0000000000405646 in globus_l_guc_expand_urls ()
#22 0x00000000004034eb in main ()

Additional info

[gmehta@hpc-opteron run0008]$ uname -a
Linux hpc-opteron 2.4.21-37.0.1.EL.1uscsmp #1 SMP Mon Feb 6 12:40:09 PST 2006
x86_64 x86_64 x86_64 GNU/Linux

[gmehta@hpc-opteron run0008]$ cat /etc/redhat-release
Red Hat Enterprise Linux AS release 3 (Taroon Update 6)

[gmehta@hpc-opteron run0008]$ ls -l /lib/ld*
-rwxr-xr-x    1 root     root        88336 Sep 29  2005 /lib/ld-2.3.2.so
lrwxrwxrwx    1 root     root           11 Dec 20  2005 /lib/ld-linux.so.2 ->
ld-2.3.2.so

[gmehta@hpc-opteron run0008]$ echo $LD_ASSUME_KERNEL
2.4.1
------- Comment #1 From 2006-07-06 18:01:59 -------
Just checked it again on a FC3 with both RH9 and FC3 binaries and they fail too
with the same error though at a different number of entries. limits on FC3
machine were 

cputime      unlimited
filesize     unlimited
datasize     unlimited
stacksize    10240 kbytes
coredumpsize unlimited
memoryuse    unlimited
vmemoryuse   unlimited
descriptors  16384
memorylocked 32 kbytes
maxproc      16375

Failed on the 8th entry

Limit on the x86_64 and x86_32 with AS3 machines was

[gmehta@hpc-master globus]$ limit
cputime         unlimited
filesize        unlimited
datasize        unlimited
stacksize       10240 kbytes
coredumpsize    unlimited
memoryuse       unlimited
vmemoryuse      unlimited
descriptors     1024
memorylocked    4 kbytes
maxproc         31488

Failed on the 3rd entry or so.
------- Comment #2 From 2006-07-06 20:09:20 -------
Looks like a problem cleaning up an error string when the directory already
exists.  Try this update package (build with 'gpt-build -update <package>
<flavor>):
http://www-unix.mcs.anl.gov/~mlink/globus_gass_copy-3.21.tar.gz

Mike
------- Comment #3 From 2006-07-06 22:26:03 -------
(In reply to comment #2)
> Looks like a problem cleaning up an error string when the directory already
> exists.  Try this update package (build with 'gpt-build -update <package>
> <flavor>):
> http://www-unix.mcs.anl.gov/~mlink/globus_gass_copy-3.21.tar.gz
> 
> Mike
> 

Ok the fix worked. I also noticed that if the both the src and dest urls are
gsiftp then also the original client worked.

Thanks
------- Comment #4 From 2006-07-06 22:58:11 -------
Right, the problem was only when creating file:// directories, and only when
enough error objects were created (internally -- not necessarily user level
errors) that the error cache started to clean up the overflow.

I'll post that package on the advisories page.
------- Comment #5 From 2006-09-15 19:57:58 -------
This has been committed to CVS and will be included in the next release.  It
was not part of the 4.0.3 release.